//+--------------------------------------------------------------------+
//|      Whistler Active Volatility Energy - Trend Manager | WAVE-TM   |
//|                        Copyright 2009, MetaQuotes Software Corp.   |
//|                                  Authors: Mark Whistler/EcTrader   |
//|                                      Mark@WallStreetRockStar.com   |
//|                www.WallStreetRockStar.com / www.fxVolatility.com   |
//|                                                                    |
//+--------------------------------------------------------------------+
#property copyright "Copyright 2009, Mark Whistler/WallStreetRockStar.com"
#property link      "http://www.wallstreetrockstar.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_color2 Blue
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_color6 Red
#property indicator_color7 Red
#property indicator_color8 Red
//---- indicator parameters
extern string aa="**Original Band Setting**";
extern int    BandsPeriod=50;
extern int    BandsShift=0;
extern double BandsDeviations=1.25;
extern string bb="**MA of Band_Lines**";
extern int Band_MA_Period=20;
extern double Ratio_Envelopes=0.1;

//---- buffers
double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];

double Up_Upper[];
double Dn_Upper[];
double Mid_Upper[];

double Up_Lower[];
double Dn_Lower[];
double Mid_Lower[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MovingBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,LowerBuffer);
   
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,Up_Upper);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,Dn_Upper);
   
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,Up_Lower);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,Dn_Lower);
//----
   SetIndexDrawBegin(0,BandsPeriod+BandsShift);
   SetIndexDrawBegin(1,BandsPeriod+BandsShift);
   SetIndexDrawBegin(2,BandsPeriod+BandsShift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;
//----
   if(Bars<=BandsPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=BandsPeriod;i++)
        {
         MovingBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer[Bars-i]=EMPTY_VALUE;
         LowerBuffer[Bars-i]=EMPTY_VALUE;
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      MovingBuffer[i]=iMA(NULL,0,BandsPeriod,BandsShift,MODE_SMA,PRICE_CLOSE,i);

//----
   i=Bars-BandsPeriod+1;
   if(counted_bars>BandsPeriod-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      sum=0.0;
      k=i+BandsPeriod-1;
      oldval=MovingBuffer[i];
      while(k>=i)
        {
         newres=Close[k]-oldval;
         sum+=newres*newres;
         k--;
        }
      deviation=BandsDeviations*MathSqrt(sum/BandsPeriod);
      UpperBuffer[i]=oldval+deviation;
      LowerBuffer[i]=oldval-deviation;
      
      double SumUp,SumDn;
      int pos;
      for(int j=i;j<(Band_MA_Period+i);j++)
        {
          SumUp+=UpperBuffer[j];
          SumDn+=LowerBuffer[j];
        }
      double Mid_upper=SumUp/Band_MA_Period;
      double Mid_lower=SumDn/Band_MA_Period;
      SumUp=0;
      SumDn=0;
      Up_Upper[i]=Mid_upper*(1+Ratio_Envelopes/100);
      Dn_Upper[i]=Mid_upper*(1-Ratio_Envelopes/100);
      Up_Lower[i]=Mid_lower*(1+Ratio_Envelopes/100);
      Dn_Lower[i]=Mid_lower*(1-Ratio_Envelopes/100);
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+